#-----------------------------------------------------------------------------
# Author:      Song Huang
#
# Created:     2004/09/07
# Copyright:   (c) 2004 ossacc.org
# License:     GPL
#-----------------------------------------------------------------------------

"""
CMF OssaccSkins Installation script

 id:            cmf_install_ossaccskins
 title:         
 module name:   OssaccSkins.Install
 function name: install
"""

from cStringIO import StringIO
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.OssaccSkins import ossaccskins_globals

def install(self):
    """
    Register "OssaccSkins" with skins.
    """
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')
    
    # Setup the skins
    if 'os01' not in skinstool.objectIds():
        _dirGreen  = ( 'os01/Images-Green',  'os01' )
        _dirCyan   = ( 'os01/Images-Cyan',   'os01' )
        _dirOrange = ( 'os01/Images-Orange', 'os01' )
        defpath=[elem.strip() for elem in skinstool.getSkinPath('Plone Default').split(',')]
        _dirs = (_dirGreen, _dirCyan, _dirOrange)
        skinsname = ('os01-Green', 'os01-Cyan', 'os01-Orange')
        for i in (0,1,2):
            paths = defpath[:]
            for d in _dirs[i]:
                try: paths.insert(paths.index('custom')+1, d)
                except ValueError: paths.append(d)
                path=','.join(paths)
                skinstool.addSkinSelection(skinsname[i], path)
        addDirectoryViews(skinstool, 'skin01', ossaccskins_globals)
        out.write("Added os01 skin directories to portal_skins\n")
    if 'os02' not in skinstool.objectIds():
        _dirGreen  = ( 'os02/Images-Green',  'os02' )
        _dirCyan   = ( 'os02/Images-Cyan',   'os02' )
        _dirOrange = ( 'os02/Images-Orange', 'os02' )
        defpath=[elem.strip() for elem in skinstool.getSkinPath('Plone Default').split(',')]
        _dirs = (_dirGreen, _dirCyan, _dirOrange)
        skinsname = ('os02-Green', 'os02-Cyan', 'os02-Orange')
        for i in (0,1,2):
            paths = defpath[:]
            for d in _dirs[i]:
                try: paths.insert(paths.index('custom')+1, d)
                except ValueError: paths.append(d)
                path=','.join(paths)
                skinstool.addSkinSelection(skinsname[i], path)
        addDirectoryViews(skinstool, 'skin02', ossaccskins_globals)
        out.write("Added os02 skin directories to portal_skins\n")
    if 'os03' not in skinstool.objectIds():
        _dirGreen  = ( 'os03/Images-Green',  'os03' )
        _dirCyan   = ( 'os03/Images-Cyan',   'os03' )
        _dirOrange = ( 'os03/Images-Orange', 'os03' )
        defpath=[elem.strip() for elem in skinstool.getSkinPath('Plone Default').split(',')]
        _dirs = (_dirGreen, _dirCyan, _dirOrange)
        skinsname = ('os03-Green', 'os03-Cyan', 'os03-Orange')
        for i in (0,1,2):
            paths = defpath[:]
            for d in _dirs[i]:
                try: paths.insert(paths.index('custom')+1, d)
                except ValueError: paths.append(d)
                path=','.join(paths)
                skinstool.addSkinSelection(skinsname[i], path)
        addDirectoryViews(skinstool, 'skin03', ossaccskins_globals)
        out.write("Added os03 skin directories to portal_skins\n")
        
    # set default
    skinstool.default_skin = 'os01-Green'

    return out.getvalue()
